unit license;

{ ############  DXF TO ILLUSTRATOR #############################}
{    1991, 1992 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{ 	Version 1.1.2  -  Main Parts Programmed by J.C. Blankert , 1991                            }
{	version 2.0 - New Licensing system, B.J. Kbben, november 1992         		     
		Version 2.2OS - code and app made OpenSource July 2002 BJK       }
{ ########################################################}

{	NOW OBSOLETE: License Numbers voor DXF to Illustrator 2.0}


interface
	uses
		{UIP}
	QuickDraw,memory,windows,fp,QuickDrawText,fonts,menus,processes,
	Dialogs,Types,TextEdit,TextUtils,toolutils,OSutils,resources,QDOffscreen,
		{MyUnits}
		globals, ErrorsAndBeeps;


	var
		LicenseTried: boolean;

	function ShowLicense (DlogPtr: DialogPtr): boolean;
	procedure voerLicenseIn;


implementation

	const
		maxLen = 32;
	var
		LName, LNumStr: str255;
		LNum: longint;
		Len: byte;

{--------------------------------------------------}
	function check (LNum: longint): boolean;

		var
			num: longint;
			extNum: extended;

	begin
		if LNum = 9999 then
			check := true
		else 
			check := false;
	end;
	{--------------------------------------------------}
	function LicenseAgreementOKd: boolean;

		const	
			AgreementDlgID = 132;
			AgreeBtn = 1;
		var
			AgreementDlog: DialogPtr;
			itemHit: integer;
			
				procedure ShowText;        {shows License agreement}
							const
								extraInfoID = 132;
								FrameID = 3; {empty useritem in DITL to determine frame}
								
							var
								i, midX, midY, itemtype: integer;
								Frame: rect;
								ExtraInfo, FrameHandle: Handle;
								
						begin
							getDialogItem(AgreementDlog, FrameID, itemtype, FrameHandle, Frame);
					
							ExtraInfo := getARes('TEXT', ExtraInfoID);
							TextFont(3); {Geneva}
							TextSize(9);
							
							TETextBox(ExtraInfo^, GetResourceSizeOnDisk(ExtraInfo), Frame, teJustLeft);
							InsetRect(Frame,-2,-2);
							TextFont(0);
							TextSize(0);
						end; {of procedure ShowText}

	begin
		
		GetPort(oldPort);
		itemHit := 0;
		AgreementDlog := GetNewDialog(AgreementDlgID, nil, pointer(-1));
		SetPort(AgreementDlog);
		showText;
		play(dong);
		ModalDialog(nil, itemHit);
		if itemHit = AgreeBtn then 
			LicenseAgreementOKd := true
		else
			LicenseAgreementOKd := false;
		DisposeDialog(AgreementDlog);
		setPort(oldPort);
	end;

{--------------------------------------------------}
	procedure voerLicenseIn;

		const
			OKitem = 1;
			CancelItem = 2;
			TextItem = 3;
		var
			InvoerDlog: DialogPtr;
			itemHit, itemType, resErr: integer;
			LNameHandle, LNumHandle: Handle;
			box: rect;

	begin
		
		if not LicenseAgreementOKd then
			begin
				thisIsdemo := true;
				SetUp^^.LicenseNum := 0;
				SetUp^^.LicenseName := 'NOT Agreed';
				
				HNoPurge(Handle(SetUpResource));
				SetUpResource^^ := Setup^^;
				ChangedResource(Handle(SetUpResource));
				writeResource(Handle(SetUpResource));
				resErr := ResError;
				if resErr <> 0 then
					error(stringOf(stringlist(ResCorruptNr), chr(13), 'Cant write Setup resource. [ResError=', resErr : 1, ']'), 0, 0, false,false);
				HPurge(Handle(SetUpResource));
				halt;
			end
		else
			begin
				thisIsDemo := false;
						
				SetUp^^.LicenseNum := 9999;
				SetUp^^.LicenseName := 'OpenSource version';
				
				HNoPurge(Handle(SetUpResource));
				SetUpResource^^ := Setup^^;
				ChangedResource(Handle(SetUpResource));
				writeResource(Handle(SetUpResource));
				resErr := ResError;
				if resErr <> 0 then
					error(stringOf(stringlist(ResCorruptNr), chr(13), 'Cant write Setup resource. [ResError=', resErr : 1, ']'), 0, 0, false,false);
				HPurge(Handle(SetUpResource));
			end;
		
	end;

{--------------------------------------------------}
	function ShowLicense (DlogPtr: DialogPtr): boolean;
		var
			theX, midX: integer;
			theStr: str255;
	begin
		ShowLicense := false;
		GetPort(oldPort);
		SetPort(DlogPtr);
		LNum := SetUp^^.LicenseNum;
		LName := SetUp^^.LicenseName;
		TextFont(Geneva); {Geneva}
		TextSize(12);
		DrawDialog(DlogPtr);
		midX := roundtol((QD.ThePort^.portrect.right - QD.ThePort^.portrect.left) / 2);
		ForeColor(yellowColor);
		if not check(LNum) then {no valid license number => demo version}
			begin
				ThisIsDemo := true;
				if not LicenseTried then {only one go per session}
					begin
						voerLicenseIn;
						LicenseTried := true;
						DrawDialog(DlogPtr); {again, because LicenseInvoer could have obscured them}
					end
				else
					play(demo);
				theStr := concat(Version, ' ', CopyRight);
				theX := roundtol(midX - stringWidth(theStr) / 2);
				Moveto(theX, DlogPtr^.portrect.bottom - 50);
				Drawstring(theStr);
				theStr := stringList(DemoVersionNr);
				theX := roundtol(midX - stringWidth(theStr) / 2);
				Moveto(theX, DlogPtr^.portrect.bottom - 25);
				Drawstring(theStr);
				DisableItem(menuList[logMenu], 0); {disable the log menu}
				drawMenuBar;
			end
		else  {valid license number}
			begin
				ThisIsDemo := false;
				theStr := concat(Version, ' ', CopyRight);
				theX := roundtol(midX - stringWidth(theStr) / 2);
				Moveto(theX, DlogPtr^.portrect.bottom - 50);
				Drawstring(theStr);
				
				theStr := concat(stringlist(LicensedToNr), LName);
				theX := roundtol(midX - stringWidth(theStr) / 2);
				Moveto(theX, DlogPtr^.portrect.bottom - 25);
				Drawstring(theStr);
				NumToString(LNum, str255(LNumStr));
				theStr := concat(stringList(LicenseNumNr), LNumStr);
				theX := roundtol(midX - stringWidth(theStr) / 2);
				Moveto(theX, DlogPtr^.portrect.bottom - 10);
				Drawstring(theStr);
				EnableItem(menuList[logMenu], 0); {enable the log menu}
				drawMenuBar;
			end;
		TextFont(0); {systemfont}
		TextSize(0);
		ForeColor(blackColor);
		ShowLicense := true;
		setPort(oldPort);
	end;

{--------------------------------------------------}
end. {of unit license}