unit globals;


{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-1997 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{ 	Version 1.1.2  -  Main Parts Programmed by J.C. Blankert , 1991                             }
{	 Version 1.2.0 -  Changes by B.J.Kbben  - 25-08-92                                                }
{                              Version string constant for about.. and splash, TieLines boolean       }
{   Version 2.0  - New Licensing mechanism - B.J. Kbben, november 1992   					}
{						- STR's changed to STR#, added stringList function- BJK august 1993	}
{						- various ID's added, LogMenu and EditMenu added- BJK august 1993		}
{	Version 2.0.1- DateTimeStr function added - BJK 3/94												}
{						- various ID's etc. added - BJK 3/94														}
{						- various ID's added, LogMenu and EditMenu added- BJK august 1993		}
{	Version 2.1- Put SetUp in Handle -BJK 8/94															
		Version 2.2OS - code and app made OpenSource July 2002 BJK	}
{ ########################################################}

interface

uses
	{Macintosh Toolbox interfaces}
	Types, Devices, Events, Dialogs, Menus, Fonts,OSUtils,
	Quickdraw, Resources, TextUtils, Toolutils, Printing

	{myUnits}
	;
	
	const

{}
		Version = '2.2-OS'; {versionstring to be shown in splash, conversion stamp and About... box}
		Copyright = '1992-2002 Utrecht University & ITC';
{}

		Dong = 130;  {IDs of snd resources for Play}
		Riedel = 129;
		Haha = 128;
		demo = 131;
		ping = 9129;

		AppleMenuID = 1000;    { resource ID of Apple Menu}
		FileMenuID = 1001; { File Menu }
		EditMenuID = 1002; {edit menu}
		LogMenuID = 1003;
		ModeMenuID=1004; 
		
		FontMenuID = 128;{Pop up menu for fonts}
		FontSizeMenuID = 129;
		EenhedenPopupID = 1006; {Pop up menu for eenheden}

		AppleMenu = 1; {menu nr's in menulist}
		FileMenu = 2;
		EditMenu = 3;
		LogMenu = 4;
		FontMenu = 5;
		FontSizeMenu = 6;
		EenhedenMenu = 7;
		ModeMenu = 8;
		NumberOfMenus = 8;

		TranslateCmd = 1; {items in File menu}
		InfoCmd = 3;
		SetupCmd = 4;
		QuitCmd = 6;

		UndoCmd = 1;
		CutCmd = 3; {items in Edit menu}
		CopyCmd = 4;
		PasteCmd = 5;
		ClearCmd = 6;

		ShowHideLogCmd = 1; {items in Log menu}
		ClearLogCmd = 2;
		OpenLogCmd = 4;
		SaveLogCmd = 5;
		FontCmd = 7;
		FontSizeCmd = 8;
		PageSetupCmd = 10;
		PrintLogCmd = 11;
		
		FastModeCmd = 1;  {items in Mode menu}
		BackgroundModeCmd = 2;
		AutoAnswerCmd = 4;

{DLOG ID's}
		GlobeCursorId = 2049; { first cursor of 6 rotating globes}
		SaveLogDlogID = 128;
		ErrorId = 1001; { Error Dialog}
		AskHatchId = 1100; { Ask for Hatching yes/no }
		AskSkipOrTryId = 1110; { Ask for Curve fit yes/ no }
		SplashDlogId = 2000; { Splash Dialog }
		SetUpId = 4000; { SetUp dialog }
		HelpDlogId = 4001; {Help for Setup}
		TableID = 4500; {fontTable dlog}
		LicenseInvoerID = 5000; {Dlog voor invoer licensenumber & name}
		LicenseAgreementID = 132; {Dlog to agree with OpenSource license}
		PrintDlogID = 131;
		LogWindowID = 128;

{STUP ID}
		stupID = 1000;

{File types}
		itsSTUP = 99; {tell create_interactive and open_interactive it' s a SetupTable}
		itsALOGF = 88; {tell create_interactive and open_interactive it' s a LogFile}

{STRINGLISTLENGTH & NUMBERS OF STRINGS IN LIST}
		stringListlength = 122;
		stringListID = 128;
		
		ConvStartedNr = 1;
		InputFileNr = 2;
		OutputFileNr = 3;
		GeneralNr = 4; { STR 'Dxf to Illustrator Conversion: ' }
		InfoNr = 5; {Str 'Dxf File Info: '}
		WarningNr = 6;{Str 'Warning: '}
		SetupStrNr = 7;{Str 'Set up: '}
		FontsNr = 8; {Str 'Finding DXF Fonts:}
		ErrStrNr = 9; { STR 'Error occured:' }
		CMDPeriodNr = 10; {'Press CMD-. to cancel' }
		BlockOFlwNr = 11; {Too Many Blocks }
		noGraphicsNr = 12; {DXF R13 - contains no graphic elements}
		NoLimitsNr = 13; {Dxf File Corrupted }
		UnXElementNr = 14; {Error reading section: }
		AbortedNr = 15; {Conversion Aborted}
		UXEntNrNr = 16; {Invalid Entity Identifier}
		BlockErrNr = 17; { Block: }
		NotFoundNr = 18; { Not Found }
		OutOfMemNr = 19; { Out of Memory }
		AbortNr = 20; {STR voor Abort button }
		CreateErrNr = 21; {STR File Create Error}
		WriteProtectNr = 22; {STR Disk write protected ?}
		OkNr = 23; { STR OK, voor Okbutton aan einde tekening }
		TargetApplNr = 24; { STR Target application is }
		TieLinesYesNr = 25; { Tieing lines}
		TieLinesNoNr = 26; { Not tieing lines}
		MarginsUsedNr = 27; { use margins}
		MarginsNotUsedNr = 28;
		ToBigForDemoNr = 29; {Str 'Sorry, maximum file size for demo-version is 275 Kb'}
		FSonNr = 30; { Don't use Font Substitution}
		FSoffNr = 31; { use FS}
		LicensedToNr = 32; { Str met license Name, stup met License ChkSum }
		LicenseNumNr = 33; {stup met Licentie nummer (longint)}
		ScaleToNr = 34; {STR toA4tall and stup met scaleToNr, 35 t/m 38 zijn de andere Strs}
		SaveSetupasNr = 39; {Save Setup table as}
		SetupIOerrNr = 40; {error in Setup File IO}
		SaveLOGFasNr = 41;{Save LogFile as}
		LOGFIOerrNr = 42; {error in LOGF IO}
		CantFindFontNr = 43; {cannot find the chosen font}
		UnknownGroupCodeNr = 44; {UnknownGroupCode}
		BusyNr = 45; {STR File busy }
		RdHeaderNr = 46; { STR  'Reading Header' }
		PrTablesNr = 47; { STR 'Processing Tables' }
		PrBlocksNr = 48; {STR 'Processing Blocks'}
		ExtentsNr = 49; { STR 'Calculating Drawing Extents'}
		RdEntitiesNr = 50; { STR 'Reading Entities'}
		WriteIllFileNr = 51; { STR 'Writing Illustrator File'}
		searchFontsNr = 52; {Str 'Looking for DXF fonts'}
		IllNameNr = 53; { STR 'New Illustrator File name ' }
		CnvReadyNr = 54; { STR 'Conversion Ready'}
		ConversionSetupNr = 55; {Conversion Setup}
		InfoForFileNr = 56; {info for file}
		NoDxfNr = 57; { STR 'File is not a Dxf File ' }
		ScaleErrorNr = 58; {STR 'Not a valNr Scale}
		NoPrinterNr = 59; {STR 'noPrinter found'}
		LogStrNr = 60; {STr 'log'}
		FontTableInfoStrNr = 61; {STR 'Font table info'}
		LogFullNr = 62; {STR 'Log Full'}
		InvoerPromptNr = 63; {Demo version until licensed'}
		DemoVersionNr = 64; {STR '{This is a Demo version'}
		ShowLogWin = 65;
		HideLogWin = 66;
		ExpectedNr = 67;
		ContainsNr = 68;
		hatchNr = 69;
		CurveFitNr = 70;
		SPlineFitNr = 71;
		ThreeDLineNr = 72;
		NotNr = 73;
		IncludedInNr = 74;
		UnexGroupTypeNr = 75;
		notImplNr = 76;
		UnsuppFldNr = 77;
		VerticesFollowNr = 78;{Unknown vertices follow flag.}
		unknownEntityNr = 79;
		OtherApplNr = 80;
		FullGroupNr = 81;
		LayerGroupNr = 82;
		NoGroupNr = 83;
		StopDemoNr = 84;
		ToManyFontsNr = 85;
		FontNr = 86;
		ColorNr = 87;
		LineStyleNr = 88;
		RGBColorNr = 89;
		InvalidStringNr = 90;
		ResCorruptNr = 91;
		CSonNr = 92;
		CSoffNr = 93;
		LSonNr = 94;
		LSoffNr = 95;
		ConvCompleteNr = 96;
		FileSizeNr = 97;
		FreehandFormatNr = 98;
		LayerFormatNr = 99;
		LineWeightNr = 100;
		FillSolidNr = 101;
		FillCircleNr = 102;
		FillPolyNr = 103;
		ConversionStampNr = 104;
		SearchColorsNr = 105;
		DXFlineNrStr = 106; {DXF line nr:}
		VerboseLoggingNr = 107; {Logging warnings}
		UnusedSectionNr = 108; {Ignoring Section  }
		UnknownSectionNr = 109; {unknown section }
		AppleEventNr = 110; {An error occured during Apple event processing.}
		NoAEMAnagerNr = 111; {This application requires System 7.0 or later to use.}
		NoAEPrintDocNr = 112; {Sorry, The PrintDoc Apple Event is not supported.}
		ConvFailedNr = 113; {### CONVERSION FAILED ###}
		DXFversNr = 114; {DXF version: }
		UnknownNoHeaderNr = 115; {DXF version unknown (No Header)}
		UnknownNr = 116; {Unknown}
		UnexpectedPlaceNr = 117; {not expected at this location}
		PolygonMeshNr = 118; {3D Polygon Mesh entities}
		PolyFaceMeshNr = 119;	{Polyface Mesh entities}
		ChangeDXFoutNr = 120; {Some applications convert linestrings to this. Check the settings of the DXF out module.}
		UnexpectedEOFnr= 121; {Found unexpected EOF}
		GroupBlocksNr = 122; {Grouping blocks}

		maxNumFonts = 20; {used for Tables}
		DefaultLW = '0.1'; {points}
		NoError = 0;
		
		{moved from layers}
		maxltypes = 50;

	type
		NameString = string[40];
		punttype = record
				x, y: real;
			end;
		reason = (normal, getFonts, getColors, getLineWeights, readingInsert);  {aanroep van ReadEntities en GetInfo}
		str80 = string[80];

		TableType = array[1..maxNumFonts] of str32;
		
		setUpRecord = record
				TargetAppl: (Ill11, Freehand, Ill50);
				Grouping: (full, bylayer, none);
				Fontsubstitution, Colorsubstitution, Lineweightsubstitution: boolean;
				LicenseName: str32;
				LicenseNum: longint;
				ConverterStamp: boolean;
				Scaling: (ToA4tall, ToA4wide, ToA3tall, ToA3wide, ToCustom);
				CustomScale: extended;
				UseMargins, Tielines, FillSolid, FillCircle, FillPoly: boolean;
				GroupBlocks: boolean; {new in 2.2}
				VerboseLogging: boolean;{used to be UseFillCol, now used for this}
				FontTable, ColorTable, LineWeightTable: TableType;{LineWeightTable now defunct}
			end;
		SetUpPtr = ^SetUprecord;
		SetUpHandle = ^SetUpPtr;
		
		{moved here from layers}
		textrecord = record
				tekst: string;
				font: Namestring;
				x, y, z, alx, aly, alz, height, scale, angle, oblangle: real;
				textgenflags, justtype: integer;
			end;
		Shortstring = string[80];
		DashRecord = record
				LTypeName: ShortString;
				DashString: string;
			end;
		

	
	var
		SetUp, SetUpResource: SetUpHandle;
		theEvent: EventRecord;  {global because fonttable edit & log  use it}
		MenuList: array[1..NumberOfMenus] of MenuHandle;  { holds menu info }
		prRecHdl: THPrint;
		thisIsDemo, InfoOnly, ItsABlock, bbox_set: boolean;
		Limits: record
				Xmin, Ymin, Xmax, Ymax, IllXmin, IllYmin, IllXmax, IllYmax: extended;
			end;
			
		OldPort: GrafPtr;
		ErrorWindow, DrawWindow,ProgressWindow: DialogPtr;
			
		numTableThings: integer;
		ACADversion,WaitingForStr : str255;
		
		{moved from entities}
		BlockCount: integer;
		BlockHatch:boolean;
		{moved from layers}
		LTypeDash: array[1..maxltypes] of DashRecord;
		
		DXFlineNr : longint;
		
		
		Finished,doBackGround,AutoAnswer,Convert_Cancelled, OneDone :boolean; {}
		DrwWinInited,ProgressWinInited,Aborted: boolean;
		numElems : longint; {keep a count for displaying File writing progress}
	
		ThreedsolidWarned,ThreedfaceWarned, attdefWarned, attribWarned, bodyWarned, 
		dimensionWarned, ellipseWarned, leaderWarned, mlineWarned, mtextWarned, 
		oleframeWarned, rayWarned, regionWarned, shapeWarned, splineWarned, 
		toleranceWarned, traceWarned, viewportWarned, xdataWarned, xlineWarned
		: boolean; 
		
		LogWinOpen,EOFencountered,DonePrinterError : boolean;
		
		openBlocks :integer;
	
		 
	function stringlist (nr: byte): str255;
	function DateTimeStr (what: integer): str255;

implementation


	function DateTimeStr (what: integer): str255;
		var
			syssecs: longint;
			dateStr, TimeStr: str255;
	begin
		GetDateTime(syssecs);
		IUDateString(syssecs, shortDate, DateStr);
		IUTimeString(syssecs, true, TimeStr);
		case what of
			0: 
				DateTimeStr := stringOf(DateStr, ' - ', TimeStr);
			1: 
				DateTimeStr := stringOf(DateStr);
			2: 
				DateTimeStr := stringOf(TimeStr);
		end; {case}
	end;


	function stringlist (nr: byte): str255;

	begin
		if (nr > 0) and (nr <= stringListLength) then
			GetIndString(stringList, StringListID, nr)
		else
			stringList := '[INTERNAL ERROR] STRING NOT FOUND IN STR#';
	end;
	


end.