unit ShowHelp;

{ ############  SHOWHELP ###################################	}
{    1994 Barend Kbben (b.kobben@frw.ruu.nl)															}
{ 		- displays help STR#'s	in modal myDialogs																	}
{ 									Version 1.0  			
		Version 2.2OS - code and app made OpenSource July 2002 BJK																	}
{ ########################################################}


interface

uses
	{UIP}
	QuickDraw,memory,windows,fp,QuickDrawText,fonts,events,QDOffscreen,
	Dialogs,Types,TextEdit,TextUtils,Processes,MixedMode,ToolUtils,
	{MyUnits}
	ErrorsAndBeeps,globals
	;
	
	var showhelpUPP: UniversalProcPtr;
		
	procedure InitShowHelp;
	procedure SetShowHelp (ID, Font, Size, Just: integer; Box: rect);
		


implementation
	
	const 
		noItem=0;
		NoError=0;
	
	var 
		HelpStringsID, HelpFont, HelpSize, HelpJust, oldItem: integer;
		HelpBox: rect;
		THelpStringsID, THelpFont, THelpSize, THelpJust, ToldItem: integer;
		THelpBox: rect;


{ --------------------------------------------------------------------------}
	FUNCTION ModalShowHelp(theDialog: DialogPtr; var theEvent:EventRecord; var TheItem:integer): Boolean;
	
		
		var
			loc: point;
			inItem,i,redirect: integer;
			theStr: str255;
			strP: StringPtr;
			
	BEGIN	
		if theDialog = nil then
			begin
			error('[ModalShowHelp] Nil Handle to theDialog',0,0,false,true);
			exitToShell;
			end;
		GetPort(oldPort);
		setPort(theDialog);
		
		GetMouse(loc);
		InItem := (findDialogItem(theDialog, loc) + 1);
		if InItem = noItem then
			begin
				oldItem := noItem;
				eraseRect(HelpBox);
			end
		else if inItem <> oldItem then
			begin
			redirect:=1;
			
			if not MemAvail(sizeof(str255)) then 
				Error('[ModalShowHelp] ', OutOfMemNr, 0, true,true);
			strP := StringPtr(newPtr(sizeof(str255)));
			
			GetIndString(theStr, HelpStringsID, inItem);
			if theStr[1]='#' then
				begin
				readstring(copy(theStr, 2,length(theStr)), redirect);
				GetIndString(theStr, HelpStringsID, redirect);
				end;
			for i := 1 to length(theStr) do
				strP^[i-1] := theStr[i];
			textFont(HelpFont);
			textSize(HelpSize);
			
			TETextBox(StrP, length(theStr), HelpBox, HelpJust);
			
			textFont(0);
			textSize(0);
			disposePtr(Ptr(strP));
			end;
		oldItem := inItem;
		
		ModalShowHelp := false; 
	
		setPort(oldPort);
	END;
	
{ --------------------------------------------------------------------------}
	procedure InitShowHelp;

		

	begin
		showhelpUPP := NewRoutineDescriptor(@ModalShowHelp,uppModalFilterProcInfo,GetCurrentISA);
		IF  showhelpUPP = NIL THEN 
			begin
			Error('[StartShowHelp] Cannot allocate showhelpUPP',0,0,false,true);
			exitToShell;
			end;	
	end;
 
{ --------------------------------------------------------------------------}
	procedure SetShowHelp (ID, Font, Size, Just: integer; Box: rect);

	begin
		HelpstringsID := ID;
		HelpFont := Font;
		HelpSize := Size;
		HelpJust := Just;
		HelpBox := Box;
		InsetRect(HelpBox, 3, 3); 
		oldItem := noItem; 
	end;
{ --------------------------------------------------------------------------}


end. {unit ShowHelp}