unit splash;

{ ############  DXF TO ILLUSTRATOR #############################}
{    1991-1994 Universiteit Utrecht, FRW, Vakgroep Kartografie &                            }
{                           International Institute for Aerospace Survey And Earth Sciences ITC  }
{ 	Version 1.1.2  -  Main Parts Programmed by J.C. Blankert , 1991                            }
{ 	Version 1.2.0  -  Changes Programmed by B.J. Kbben, 24-08-92                             }
{ 	                          - Put Version string (in unit global) into Splash                               }
{ 	                          - Splash and About.. in same procedure, use same DLOG&DITL         }
{ 	                          - Modified Splash with  extra info text                        
		Version 2.2OS - code and app made OpenSource July 2002 BJK                   }
{ ########################################################}

interface
	uses
		{UIP}
	QuickDraw,memory,windows,fp,QuickDrawText,fonts,menus,processes,
	Dialogs,Types,TextEdit,TextUtils,toolutils,OSutils,events,resources,
		{MyUnits}
			globals, license, ErrorsAndBeeps;

	const
		asSplash = 1;
		asAboutBox = 2;


	procedure dosplash (asWhat: integer);  {asSplash or asAboutBox}

implementation

	procedure dosplash (asWhat: integer);  {asSplash or asAboutBox}
		var
			DlogPtr: DialogPtr;
			wrect: rect;
			LicenseResult: boolean;
			start: longint;

		procedure ShowText;        {shows extra info in About.. box -- BJK 21-08-92}
			const
				extraInfoID = 128;
				FrameID = 1; {empty useritem in DITL to determine frame}
				PictID = 131;
			var
				i, midX, midY, itemtype: integer;
				myRect, Frame: rect;
				ExtraInfo, FrameHandle: Handle;
		begin
			flushEvents(everyEvent, 0);
			SetPort(DlogPtr);
			getDialogItem(DlogPtr, FrameID, itemtype, FrameHandle, MyRect);
			if BitAnd(TheEvent.modifiers, cmdKey + shiftKey + optionKey) <> 0 then
				begin
					DrawPicture(GetPicture(PictID), MyRect);
					play(Haha);
				end
			else
				begin
					ExtraInfo := getARes('TEXT', ExtraInfoID);
					Frame := MyRect;
					InsetRect(Frame, 3, 2);
					ClipRect(MyRect);
					TextFont(3); {Geneva}
					TextSize(10);
					midX := roundtol(MyRect.right / 2);
					midY := roundtol(MyRect.bottom / 2);
					for i := 1 to midY do
						begin
							SetRect(MyRect, midX - (i * 2), midY - i, midX + (i * 2), midY + i);
							EraseRect(MyRect);
						end;
					TETextBox(ExtraInfo^, GetResourceSizeOnDisk(ExtraInfo), Frame, teJustCenter);
					InsetRect(Frame, -3, -2);
					FrameRect(Frame);
				end; {of if-then-else}
		end; {of procedure ShowText}

	begin
		SetCursor(QD.arrow);
		start := TickCount;
		DlogPtr := GetNewDialog(SplashDlogId, nil, Pointer(-1));
		wrect := QD.screenbits.bounds;
		with wrect do
			begin
				insetRect(wrect, 0, roundtol((bottom - top) * 0.1));
				top := top + 50;
				MoveWindow(DlogPtr, roundtol((right + left) / 2) - 156, top, True);
			end;
		showWindow(DlogPtr);
		LicenseResult := ShowLicense(DlogPtr);
		case asWhat of
			asSplash: 
				begin
					flushEvents(everyEvent, 0);
					repeat
					until GetNextEvent((mDownMask), theEvent) or EventAvail((keyDownMask), theEvent) or (theEvent.when - start > 100);
					if (DlogPtr^.portrect.bottom - DlogPtr^.portRect.top < 100) then
						begin
							play(dong);
							play(dong);
							play(dong);
							play(dong);
							play(dong);
							play(dong);
							halt; { Iemand heeft Intro window te klein gemaakt voor licentie vermelding  of chksum fout}
						end;
				end;
			asAboutBox: 
				begin
					Play(Riedel);
					repeat
					until GetNextEvent((mDownMask + keyDownMask + autoKeyMask), theEvent);
					showText;
					repeat
					until GetNextEvent((mDownMask), theEvent) or EventAvail((keyDownMask), theEvent);
				end;
		end; {case}
		DisposeDialog(Dlogptr);
	end;

end. {of unit splash}